/*
Circoflex kite.

Diameter: 3.18 units
*/

// Colour and finish:
#local ccolour=BrightGold; // from colors.inc
#local cfinish=finish { reflection 0.25 specular 5 }

#local linethick = 0.004;
#local spar = 0.03;
#local towpoint = <0, -3, -0.35>;
#local flier = <0, -100, -100>;

#declare circo = union {
    #local br1 = <0, -0.55, -0.8>;
    #local br2 = <0, -0.75, -0.8>;
    #local rad = 5/pi;
    cone{<0, 0, 0>, rad, <0, 0, 0.6>, rad*.98 open
    texture { pigment {ccolour } finish { cfinish } } }
    //torus{rad, linethick rotate <90, 0, 0> pigment {colour rgb 0}}
    cylinder{<0, rad, 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<rad*sin(pi/6), rad*cos(pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<rad*sin(2*pi/6), rad*cos(2*pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<rad*sin(3*pi/6), rad*cos(3*pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<rad*sin(4*pi/6), rad*cos(4*pi/6), 0>, br2, linethick pigment {colour rgb 0 }}
    cylinder{<rad*sin(5*pi/6), rad*cos(5*pi/6), 0>, br2, linethick pigment {colour rgb 0 }}
    cylinder{<-rad*sin(pi/6), rad*cos(pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<-rad*sin(2*pi/6), rad*cos(2*pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<-rad*sin(3*pi/6), rad*cos(3*pi/6), 0>, br1, linethick pigment {colour rgb 0 }}
    cylinder{<-rad*sin(4*pi/6), rad*cos(4*pi/6), 0>, br2, linethick pigment {colour rgb 0 }}
    cylinder{<-rad*sin(5*pi/6), rad*cos(5*pi/6), 0>, br2, linethick pigment {colour rgb 0 }}
    cylinder{<0, -rad, 0>, br2, linethick pigment {colour rgb 0 }}
    cylinder{br1, br2, linethick pigment {colour rgb 0 }}
    cylinder{(br1 + br2)/2, flier, linethick pigment {colour rgb 0 }}
    rotate <20, 0, 0>
}
