/*
Delta Conyne kite.

Length: 3.3 units
Width:  6.6 units
*/

// Colours:
#local colour1 = rgb<1.5, 1.5, 0>;
#local colour2 = rgb<1, 0, 0>;
#local colour3 = rgb<0, 0, 1>;

#local len = 2.3;
#local z1 = 1.4;
#local wingspan = 3.3;
#local linethick = 0.01;
#local spar = 0.03;
#local towpoint = <0, -2, -0.5>;
#local flier = 100 * towpoint;

#local front = union {
    polygon{5, <0.5, 0, -1>, <0.5, 0, 0>, <-0.5, 0, 0>, <-0.5, 0, -1>, <0.5, 0, -1>}
    polygon{5, <0.5, 0, -1>, <0.5, 0, 0>,  <0, -sqrt(3)/2, 0>, <0, -sqrt(3)/2, -1>, <0.5, 0, -1>}
    polygon{5, <-0.5, 0, -1>, <-0.5, 0, 0>,  <0, -sqrt(3)/2, 0>, <0, -sqrt(3)/2, -1>, <-0.5, 0, -1>}
    cylinder{<0.5, 0, 0>, <-0.5, 0, 0>, linethick pigment{rgb 0}}
    cylinder{<-0.5, 0, -1>, <0.5, 0, -1>, linethick pigment{rgb 0}}
    cylinder{<0.5, 0, 0>,  <0, -sqrt(3)/2, 0>, linethick pigment{rgb 0}}
    cylinder{<0, -sqrt(3)/2, -1>, <0.5, 0, -1>, linethick pigment{rgb 0}}
    cylinder{<-0.5, 0, 0>,  <0, -sqrt(3)/2, 0>, linethick pigment{rgb 0}}
    cylinder{<0, -sqrt(3)/2, -1>, <-0.5, 0, -1>, linethick pigment{rgb 0}}
}

#local wing = union {
    polygon{4, <0.5, 0, -1>, <wingspan, 0, len>, <0.5, 0, len>, <0.5, 0, -1> pigment{colour1}}
    cylinder{<0.5, 0, -1>, <wingspan, 0, len>, linethick pigment{rgb 0}}
    cylinder{<(wingspan-0.5)/(1+len)+0.5, 0, 0>, <wingspan, 0, len>, spar pigment{rgb 0}}
    cylinder{<wingspan, 0, len>, <0.5, 0, len>, linethick pigment{rgb 0}}
    cylinder{<0.5, 0, len>, <0.5, 0, -1>, linethick pigment{rgb 0}}
}

#declare dconyne = union {
    object{front pigment{colour2}}
    object{front translate <0, 0, len> pigment{colour3}}
    object{wing}
    object{wing rotate <0, 0, 180>}
    cylinder{<0.5, 0, -1>, <0.5, 0, len>, spar pigment{rgb 0}}
    cylinder{<-0.5, 0, -1>, <-0.5, 0, len>, spar pigment{rgb 0}}
    cylinder{<0, -sqrt(3)/2, -1>, <0, -sqrt(3)/2, len>, spar pigment{rgb 0}}
    cylinder{<(wingspan-0.5)*z1/(1+len)+0.5, 0, z1-1>, <-(wingspan-0.5)*z1/(1+len)-0.5, 0, z1-1>, spar pigment{rgb 0}}
    
    cylinder{<0, -sqrt(3)/2, -1>, towpoint, linethick pigment{rgb 0}}
    cylinder{towpoint, <0, -sqrt(3)/2, len-1>, linethick pigment{rgb 0}}
    cylinder{towpoint, flier, linethick pigment{rgb 0}}
    rotate <25, 0, 0>
}
