/*
Pely Box, or Tri-D kite (3-cell).

Length: 4.24 units
Width:  2.41 units
*/

// Colours:
#local TriD_colour1 = rgb <2.5, 2.5, 0>;
#local TriD_colour2 = rgb <0, 0, 1>;
#local TriD_colour3 = rgb <1, 0, 0>;

#local Towpoint = <0, -2.4, -3>;
#local Flier = <0, -500, -300>;
#local linethick = 0.005;
  
#local sail = union {
    cylinder { <0, 0, 0>, <-1, 0, 0,>, linethick pigment {rgb 0}}
    cylinder { <-1, 0, 0,> <0, 0, 1>, linethick pigment {rgb 0}}
    cylinder { <0, 0, 1>, <0, 0, 0>, linethick pigment {rgb 0}}
    polygon { 4, <0, 0, 0>, <-1, 0, 0,> <0, 0, 1>, <0, 0, 0> }
    rotate <0, -45,0>  
    translate <sqrt(2)/2, 0, 0>
} 
  
#local half_cell = union {
    object { sail  pigment { color TriD_colour1 } }
    object { sail rotate <0, 0, 135>  pigment { color TriD_colour2 }}
    object { sail rotate <0, 0, 225>  pigment { color TriD_colour3 }}
    cylinder { <-0.5, 0, 0>, <sqrt(2)/2, 0, 0>, 0.01 pigment {rgb 0} }
    cylinder { <0, 0, sqrt(2)/2>, <0, 0, -sqrt(2)/2>, 0.01 pigment {rgb 0} }
}   
  
#local cell = union {
    object { half_cell translate <0.5, 0, 0> }
    object { half_cell translate <0.5, 0, 0> rotate <0, 180, 0> }
    cylinder { <0, 0.5, 0>, <0, -0.5, 0>, 0.01 pigment {rgb 0} }
}
  
#declare pely = union {
    object { cell rotate <0, 0, 0> }
    object { cell translate <0, 0, sqrt(2)> }
    object { cell translate <0, 0, -sqrt(2)> }
    cylinder { <-0.5, 0, -1.5*sqrt(2)>, Towpoint, 0.005 pigment {rgb 0} }
    cylinder { <0.5, 0, -1.5*sqrt(2)>, Towpoint, 0.005 pigment {rgb 0} }
    cylinder { <0, -0.5, sqrt(2)>, Towpoint, 0.005 pigment {rgb 0} }
    cylinder { Towpoint, Flier, 0.005 pigment {rgb 0}}
    rotate <30, 0, 0>
}