/*
Snowflake kite - kaleidescopic colour scheme.

Diameter: 2 units
*/

// Colours:
#local Snowflake_colour1 = rgb <0, 1, 0>;
#local Snowflake_colour2 = rgb <1, 1, 0>;
#local Snowflake_colour3 = rgb <1, 0, 0>;


#local s = 3;
#local linethick = 0.002/s;
#local towpoint = <0, -2.0, -1.2>;

#local sail1 = union {
    cylinder { <0, 0, sqrt(2)/2>, <1/3, 0, sqrt(2)/3>, linethick pigment {rgb 0}}
    cylinder { <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>, linethick pigment {rgb 0}}
    cylinder { <1/3, 0, -sqrt(2)/3>, <0, 0, -sqrt(2)/2>, linethick pigment {rgb 0}}
    cylinder { <0, 0, -sqrt(2)/2>, <0, 0, sqrt(2)/2>, linethick pigment {rgb 0}}
    polygon { 5,
      <0, 0, sqrt(2)/2>, <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>,
      <0, 0, -sqrt(2)/2>, <0, 0, sqrt(2)/2>
    } 
}

#local sail2 = union {
    polygon {
      5,
      <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>,
      <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>,
      <1/3, 0, sqrt(2)/3>
    }
    cylinder { <1/3, 0, -sqrt(2)/3>, <2/3, 0, -sqrt(2)/6>, linethick pigment {rgb 0}}
    cylinder { <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>, linethick pigment {rgb 0}}
    cylinder { <2/3, 0, sqrt(2)/6>, <1/3, 0, sqrt(2)/3>, linethick pigment {rgb 0}}
}

#local sail3 = union {
    polygon {
      4,
      <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>,
      <1, 0, 0>, <2/3, 0, -sqrt(2)/6>
    }
    cylinder { <2/3, 0, sqrt(2)/6>, <1, 0, 0>, linethick pigment {rgb 0}}
    cylinder { <1, 0, 0>, <2/3, 0, -sqrt(2)/6>, linethick pigment {rgb 0}}
}

#macro snowflk1_section(c1, c2, c3, R)
union {
    object { sail1 pigment{colour c1}}
  
    object { sail2 pigment{colour c2}}
    object { sail2 translate <-1/3, 0, 0> rotate <0, 0, 60> translate <1/3, 0, 0>
      pigment{colour c1}}
    object { sail2 translate <-1/3, 0, 0> rotate <0, 0, -60> translate <1/3, 0, 0>
      pigment{colour c2}}
      
    object { sail3 pigment{colour c3}}
    object { sail3 translate <-2/3, 0, 0> rotate <0, 0, 60> translate <2/3, 0, 0>
      pigment{colour c2}}
    object { sail3 translate <-2/3, 0, 0> rotate <0, 0, -60> translate <2/3, 0, 0>
      pigment{colour c3}}
    object { sail3 translate <-1/6, sqrt(3)/6, 0> pigment{colour c1}}
    object { sail3 translate <-1/6, -sqrt(3)/6, 0> pigment{colour c2}}
  
    cylinder { <5/6, sqrt(3)/6, 0>, <cos(2*pi*20/360), sin(2*pi*20/360), 0>, 0.005 pigment {rgb 0} }
    cylinder { <5/6, -sqrt(3)/6, 0>, <cos(2*pi*20/360), -sin(2*pi*20/360), 0>, 0.005 pigment {rgb 0} }
    rotate <0, 0, R>
}
#end

#declare snowflake1 = union {
    snowflk1_section(Snowflake_colour1, Snowflake_colour2, Snowflake_colour3, 0)
    snowflk1_section(Snowflake_colour2, Snowflake_colour3, Snowflake_colour1, 60)
    snowflk1_section(Snowflake_colour3, Snowflake_colour1, Snowflake_colour2, 120)
    snowflk1_section(Snowflake_colour1, Snowflake_colour2, Snowflake_colour3, 180)
    snowflk1_section(Snowflake_colour2, Snowflake_colour3, Snowflake_colour1, 240)
    snowflk1_section(Snowflake_colour3, Snowflake_colour1, Snowflake_colour2, 300)
    torus { 1, 0.01 rotate <90, 0, 0> pigment {rgb 0}}
    cylinder {<0, 0, -sqrt(2)/2>, towpoint, 0.005 pigment {rgb 0} }
    cylinder {<sin(2*pi*30/360), -cos(2*pi*30/360), >, towpoint, 0.005 pigment {rgb 0}}
    cylinder {<-sin(2*pi*30/360), -cos(2*pi*30/360), >, towpoint, 0.005 pigment {rgb 0}}
    cylinder {towpoint, towpoint*100, 0.005 pigment {rgb 0}}
    scale s
    rotate <25, 0, 0>
}
#macro snowflk1_section()
#end
