/*
Snowflake kite - concentric colour scheme.

Diameter: 2 units
*/

// Colours:
#local Snowflake_colour1 = rgb <0.7, 1, 0.7>;
#local Snowflake_colour2 = rgb <0.3, 1, 0.3>;
#local Snowflake_colour3 = rgb <0.2, 0.2, 1>;

#local s = 3;
#local linethick = 0.002/s;
#local towpoint = <0, -2.0, -1.2>;

#local sail1 = union {
    cylinder { <0, 0, sqrt(2)/2>, <1/3, 0, sqrt(2)/3>, linethick pigment {rgb 0}}
    cylinder { <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>, linethick pigment {rgb 0}}
    cylinder { <1/3, 0, -sqrt(2)/3>, <0, 0, -sqrt(2)/2>, linethick pigment {rgb 0}}
    cylinder { <0, 0, -sqrt(2)/2>, <0, 0, sqrt(2)/2>, linethick pigment {rgb 0}}
    polygon { 5,
      <0, 0, sqrt(2)/2>, <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>,
      <0, 0, -sqrt(2)/2>, <0, 0, sqrt(2)/2>
    } 
    pigment {colour Snowflake_colour1}
}

#local sail2 = union {
    polygon { 5,
      <1/3, 0, sqrt(2)/3>, <1/3, 0, -sqrt(2)/3>,
      <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>,
      <1/3, 0, sqrt(2)/3>
    }
    cylinder { <1/3, 0, -sqrt(2)/3>, <2/3, 0, -sqrt(2)/6>, linethick pigment {rgb 0}}
    cylinder { <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>, linethick pigment {rgb 0}}
    cylinder { <2/3, 0, sqrt(2)/6>, <1/3, 0, sqrt(2)/3>, linethick pigment {rgb 0}}
    pigment {colour Snowflake_colour2}
}

#local sail3 = union {
    polygon { 4,
      <2/3, 0, -sqrt(2)/6>, <2/3, 0, sqrt(2)/6>,
      <1, 0, 0>, <2/3, 0, -sqrt(2)/6>
    }
    cylinder { <2/3, 0, sqrt(2)/6>, <1, 0, 0>, linethick pigment {rgb 0}}
    cylinder { <1, 0, 0>, <2/3, 0, -sqrt(2)/6>, linethick pigment {rgb 0}}
    pigment {colour Snowflake_colour3}
}

#local section = union {
    object { sail1 }
    object { sail2 }
    object { sail2 translate <-1/3, 0, 0> rotate <0, 0, 60> translate <1/3, 0, 0> }
    object { sail2 translate <-1/3, 0, 0> rotate <0, 0, -60> translate <1/3, 0, 0> }
    object { sail3 }
    object { sail3 translate <-2/3, 0, 0> rotate <0, 0, 60> translate <2/3, 0, 0> }
    object { sail3 translate <-2/3, 0, 0> rotate <0, 0, -60> translate <2/3, 0, 0> }
    object { sail3 translate <-1/6, sqrt(3)/6, 0>}
    object { sail3 translate <-1/6, -sqrt(3)/6, 0>}
    cylinder { <5/6, sqrt(3)/6, 0>, <cos(2*pi*20/360), sin(2*pi*20/360), 0>, 0.005 pigment {rgb 0} }
    cylinder { <5/6, -sqrt(3)/6, 0>, <cos(2*pi*20/360), -sin(2*pi*20/360), 0>, 0.005 pigment {rgb 0} }
}

#declare snowflake2 = union {
    object { section }
    object { section rotate <0, 0, 60> }
    object { section rotate <0, 0, 120> }
    object { section rotate <0, 0, 180> }
    object { section rotate <0, 0, 240> }
    object { section rotate <0, 0, 300> }
    torus { 1, 0.01 rotate <90, 0, 0> pigment {rgb 0}}
    cylinder {<0, 0, -sqrt(2)/2>, towpoint, 0.005 pigment {rgb 0} }
    cylinder {<sin(2*pi*30/360), -cos(2*pi*30/360), >, towpoint, 0.005 pigment {rgb 0}}
    cylinder {<-sin(2*pi*30/360), -cos(2*pi*30/360), >, towpoint, 0.005 pigment {rgb 0}}
    cylinder {towpoint, towpoint*100, 0.005 pigment {rgb 0}}
    scale s
    rotate <25, 0, 0>
}

