/*
Tumbling Star kite.

Diameter: 3.3 units
Depth:  1 unit
*/

// Colours:
#local colour1=rgb<0, 0.5, 1>; 
#local colour2=rgb<0, 1, 0>; 
#local colour3=rgb<1, 1, 0>; 

#local linethick = 0.009;
#local spar = 0.03;
#local towpoint = <0, -4, -5.5>;
#local flier = 100*towpoint;

#local sect = union {
    polygon{5, <1.5, sqrt(3)/2, -0.5>, <1.5, sqrt(3)/2, 0.5>,
        <0.5, sqrt(3)/2, 0.5>,  <0.5, sqrt(3)/2, -0.5>,
        <1.5, sqrt(3)/2, -0.5> pigment{colour2} }
    polygon{5, <-0.5, sqrt(3)/2, -0.5>, <-0.5, sqrt(3)/2, 0.5>,
        <-1.5, sqrt(3)/2, 0.5>,  <-1.5, sqrt(3)/2, -0.5>,
        <-0.5, sqrt(3)/2, -0.5> pigment{colour2} }
    polygon{5, <0.5, sqrt(3)/2, -0.5>, <0.5, sqrt(3)/2, 0.5>,
        <-0.5, sqrt(3)/2, 0.5>,  <-0.5, sqrt(3)/2, -0.5>,
        <0.5, sqrt(3)/2, -0.5> pigment{colour1} }
    cylinder { <1.5, sqrt(3)/2, 0.5>, <-1.5, sqrt(3)/2, 0.5>,
        linethick pigment {rgb 0}}
    cylinder { <-1.5, sqrt(3)/2, 0.5>,  <-1.5, sqrt(3)/2, -0.5>,
        linethick pigment {rgb 0}}
    cylinder { <-1.5, sqrt(3)/2, -0.5>, <1.5, sqrt(3)/2, -0.5>,
        linethick pigment {rgb 0}}
    cylinder { <-1.5, sqrt(3)/2, -0.5>, <1.5, sqrt(3)/2, -0.5>,
        linethick pigment {rgb 0}}
    cylinder { <0.5, sqrt(3)/2, -0.5>, <0.5, sqrt(3)/2, 0.5>,
        linethick pigment {rgb 0}}
    union {
        polygon {4, <sqrt(3), 0, -0.5>, <sqrt(3), 0, 0.5>, 
            <3*sqrt(3)/2, 0, 0>, <sqrt(3), 0, -0.5> }
        cylinder { <sqrt(3), 0, -0.5>, <sqrt(3), 0, 0.5>,
            linethick pigment {rgb 0}}
        cylinder { <sqrt(3), 0, 0.5>, <3*sqrt(3)/2, 0, 0>,
            linethick pigment {rgb 0}}
        cylinder { <3*sqrt(3)/2, 0, 0>, <sqrt(3), 0, -0.5>,
            linethick pigment {rgb 0}}
        cylinder { <3*sqrt(3)/2, 0, 0>, <0,0,0>,
            spar pigment {colour rgb 0}}
        rotate <0, 0, 30> pigment{colour3} }
}

#declare tumbstar = union {
    object{sect}
    object{sect rotate <0, 0, 60>}
    object{sect rotate <0, 0, 120>}
    object{sect rotate <0, 0, 180>}
    object{sect rotate <0, 0, 240>}
    object{sect rotate <0, 0, 300>}
    cylinder { <0, 3*sqrt(3)/2, 0>, towpoint, linethick pigment{colour rgb 0}}
    cylinder { <-2.25, -3*sqrt(3)/4, 0>, towpoint, linethick pigment{colour rgb 0}}
    cylinder { <2.25, -3*sqrt(3)/4, 0>, towpoint, linethick pigment{colour rgb 0}}
    cylinder { flier, towpoint, linethick pigment{colour rgb 0}}
    rotate <23, 0, 0>
}