/*
Winged Box kite.

Length: 4 units
Width:  4 units
*/

// Colours:
#local colour1 = rgb<1, 0, 0>;
#local colour2 = rgb<0, 1, 0>;

#local x1 = 1;
#local x2 = 2;
#local z1 = 1;
#local z2 = 3;
#local linethick = 0.01;
#local spar = 0.03;
#local towpoint = <0, -3, -0.35>;
#local flier = 100 * towpoint;

#local quarterbox = union {
    polygon{5, <x1, 0, 0>, <x1, 0, -z1>, <0, x1, -z1>,
            <0, x1, 0>, <x1, 0, 0>
            pigment{colour colour1 } }
    cylinder { <x1, 0, 0>, <x1, 0, -z1>, linethick pigment{rgb 0} }
    cylinder { <x1, 0, -z1>, <0, x1, -z1>, linethick pigment{rgb 0} }
    cylinder { <0, x1, -z1>, <0, x1, 0>, linethick pigment{rgb 0} }
    cylinder { <0, x1, 0>, <x1, 0, 0>, linethick pigment{rgb 0} }
    polygon{5, <x1, 0, z2>, <x1, 0, z2-z1>, <0, x1, z2-z1>,
            <0, x1, z2>, <x1, 0, z2>
            pigment{colour colour1 } }
    cylinder { <x1, 0, z2>, <x1, 0, z2-z1>, linethick pigment{rgb 0} }
    cylinder { <x1, 0, z2-z1>, <0, x1, z2-z1>, linethick pigment{rgb 0} }
    cylinder { <0, x1, z2-z1>, <0, x1, z2>, linethick pigment{rgb 0} }
    cylinder { <0, x1, z2>, <x1, 0, z2>, linethick pigment{rgb 0} }
    polygon{4, <x1, 0, -z1>, <x1, 0, z2>, <x2, 0, 0>, <x1, 0, -z1>
            pigment{colour colour2 } }
    cylinder { <x1, 0, -z1>, <x1, 0, z2>, linethick pigment{rgb 0} }
    cylinder { <x1, 0, z2>, <x2, 0, 0>, linethick pigment{rgb 0} }
    cylinder { <x2, 0, 0>, <x1, 0, -z1>, linethick pigment{rgb 0} }
    
    cylinder { <x1, 0, -z1>, <x1, 0, z2>, spar pigment{rgb 0} }
    cylinder { <0, 0, 0>, <x2, 0, 0>, spar pigment{rgb 0} }
    cylinder { <0, 0, z2-z1>, <x1, 0, z2-z1>, spar pigment{rgb 0} }   
}
#declare wingbox = union {
    object {quarterbox}
    object {quarterbox rotate <0, 0, 90>}
    object {quarterbox rotate <0, 0, 180>}
    object {quarterbox rotate <0, 0, 270>}
    cylinder { <0, -x1, -z1>, towpoint, linethick pigment{rgb 0} }
    cylinder { <0, -x1, z2>, towpoint, linethick pigment{rgb 0} }
    cylinder { towpoint, flier, linethick pigment{rgb 0} }
    rotate <30, 0, 0>
}